/**
 * VampirTrace
 * http://www.tu-dresden.de/zih/vampirtrace
 *
 * Copyright (c) 2005-2010, ZIH, TU Dresden, Federal Republic of Germany
 *
 * Copyright (c) 1998-2005, Forschungszentrum Juelich, Juelich Supercomputing
 *                          Centre, Federal Republic of Germany
 *
 * See the file COPYING in the package base directory for details
 *
 * !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 * ! BUILT BY mk_c_wrapper.sh; DO NOT EDIT THIS FILE       !
 * !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 **/

/* -- MPI_Abort -- */

VT_MPI_INT MPI_Abort(MPI_Comm comm, VT_MPI_INT errorcode)
{
  VT_MPI_INT result;
  uint64_t time;
  uint8_t was_recorded;

  if (IS_MPI_TRACE_ON)
  {
    MPI_TRACE_OFF();

    time = vt_pform_wtime();
    was_recorded = vt_enter(&time, vt_mpi_regid[VT__MPI_ABORT]);

    CALL_PMPI_2(MPI_Abort, comm, errorcode, result, 0, was_recorded, &time);

    time = vt_pform_wtime();
    vt_exit(&time);

    MPI_TRACE_ON();
  }
  else
  {
    CALL_PMPI_2(MPI_Abort, comm, errorcode, result, 0, 0, NULL);
  }

  return result;
}

/* -- MPI_Address -- */

VT_MPI_INT MPI_Address(void* location, MPI_Aint* address_CLASS_SINGLE_OUT)
{
  VT_MPI_INT result;
  uint64_t time;
  uint8_t was_recorded;

  if (IS_MPI_TRACE_ON)
  {
    MPI_TRACE_OFF();

    time = vt_pform_wtime();
    was_recorded = vt_enter(&time, vt_mpi_regid[VT__MPI_ADDRESS]);

    CALL_PMPI_2(MPI_Address, location, address_CLASS_SINGLE_OUT, result, 0, was_recorded, &time);

    time = vt_pform_wtime();
    vt_exit(&time);

    MPI_TRACE_ON();
  }
  else
  {
    CALL_PMPI_2(MPI_Address, location, address_CLASS_SINGLE_OUT, result, 0, 0, NULL);
  }

  return result;
}

/* -- MPI_Allgather -- not generated */

/* -- MPI_Allgatherv -- not generated */

/* -- MPI_Allreduce -- not generated */

/* -- MPI_Alltoall -- not generated */

/* -- MPI_Alltoallv -- not generated */

/* -- MPI_Attr_delete -- */

VT_MPI_INT MPI_Attr_delete(MPI_Comm comm, VT_MPI_INT keyval)
{
  VT_MPI_INT result;
  uint64_t time;
  uint8_t was_recorded;

  if (IS_MPI_TRACE_ON)
  {
    MPI_TRACE_OFF();

    time = vt_pform_wtime();
    was_recorded = vt_enter(&time, vt_mpi_regid[VT__MPI_ATTR_DELETE]);

    CALL_PMPI_2(MPI_Attr_delete, comm, keyval, result, 0, was_recorded, &time);

    time = vt_pform_wtime();
    vt_exit(&time);

    MPI_TRACE_ON();
  }
  else
  {
    CALL_PMPI_2(MPI_Attr_delete, comm, keyval, result, 0, 0, NULL);
  }

  return result;
}

/* -- MPI_Attr_get -- */

VT_MPI_INT MPI_Attr_get(MPI_Comm comm, VT_MPI_INT keyval, void* attribute_val, VT_MPI_INT* flag)
{
  VT_MPI_INT result;
  uint64_t time;
  uint8_t was_recorded;

  if (IS_MPI_TRACE_ON)
  {
    MPI_TRACE_OFF();

    time = vt_pform_wtime();
    was_recorded = vt_enter(&time, vt_mpi_regid[VT__MPI_ATTR_GET]);

    CALL_PMPI_4(MPI_Attr_get, comm, keyval, attribute_val, flag, result, 0, was_recorded, &time);

    time = vt_pform_wtime();
    vt_exit(&time);

    MPI_TRACE_ON();
  }
  else
  {
    CALL_PMPI_4(MPI_Attr_get, comm, keyval, attribute_val, flag, result, 0, 0, NULL);
  }

  return result;
}

/* -- MPI_Attr_put -- */

VT_MPI_INT MPI_Attr_put(MPI_Comm comm, VT_MPI_INT keyval, void* attribute_val)
{
  VT_MPI_INT result;
  uint64_t time;
  uint8_t was_recorded;

  if (IS_MPI_TRACE_ON)
  {
    MPI_TRACE_OFF();

    time = vt_pform_wtime();
    was_recorded = vt_enter(&time, vt_mpi_regid[VT__MPI_ATTR_PUT]);

    CALL_PMPI_3(MPI_Attr_put, comm, keyval, attribute_val, result, 0, was_recorded, &time);

    time = vt_pform_wtime();
    vt_exit(&time);

    MPI_TRACE_ON();
  }
  else
  {
    CALL_PMPI_3(MPI_Attr_put, comm, keyval, attribute_val, result, 0, 0, NULL);
  }

  return result;
}

/* -- MPI_Barrier -- not generated */

/* -- MPI_Bcast -- not generated */

/* -- MPI_Bsend -- not generated */

/* -- MPI_Bsend_init -- not generated */

/* -- MPI_Buffer_attach -- */

VT_MPI_INT MPI_Buffer_attach(void* buf, VT_MPI_INT size)
{
  VT_MPI_INT result;
  uint64_t time;
  uint8_t was_recorded;

  if (IS_MPI_TRACE_ON)
  {
    MPI_TRACE_OFF();

    time = vt_pform_wtime();
    was_recorded = vt_enter(&time, vt_mpi_regid[VT__MPI_BUFFER_ATTACH]);

    CALL_PMPI_2(MPI_Buffer_attach, buf, size, result, 0, was_recorded, &time);

    time = vt_pform_wtime();
    vt_exit(&time);

    MPI_TRACE_ON();
  }
  else
  {
    CALL_PMPI_2(MPI_Buffer_attach, buf, size, result, 0, 0, NULL);
  }

  return result;
}

/* -- MPI_Buffer_detach -- */

VT_MPI_INT MPI_Buffer_detach(void* buf, VT_MPI_INT* size)
{
  VT_MPI_INT result;
  uint64_t time;
  uint8_t was_recorded;

  if (IS_MPI_TRACE_ON)
  {
    MPI_TRACE_OFF();

    time = vt_pform_wtime();
    was_recorded = vt_enter(&time, vt_mpi_regid[VT__MPI_BUFFER_DETACH]);

    CALL_PMPI_2(MPI_Buffer_detach, buf, size, result, 0, was_recorded, &time);

    time = vt_pform_wtime();
    vt_exit(&time);

    MPI_TRACE_ON();
  }
  else
  {
    CALL_PMPI_2(MPI_Buffer_detach, buf, size, result, 0, 0, NULL);
  }

  return result;
}

/* -- MPI_Cancel -- not generated */

/* -- MPI_Cart_coords -- */

VT_MPI_INT MPI_Cart_coords(MPI_Comm comm, VT_MPI_INT rank, VT_MPI_INT maxdims, VT_MPI_INT* coords)
{
  VT_MPI_INT result;
  uint64_t time;
  uint8_t was_recorded;

  if (IS_MPI_TRACE_ON)
  {
    MPI_TRACE_OFF();

    time = vt_pform_wtime();
    was_recorded = vt_enter(&time, vt_mpi_regid[VT__MPI_CART_COORDS]);

    CALL_PMPI_4(MPI_Cart_coords, comm, rank, maxdims, coords, result, 0, was_recorded, &time);

    time = vt_pform_wtime();
    vt_exit(&time);

    MPI_TRACE_ON();
  }
  else
  {
    CALL_PMPI_4(MPI_Cart_coords, comm, rank, maxdims, coords, result, 0, 0, NULL);
  }

  return result;
}

/* -- MPI_Cart_create -- not generated */

/* -- MPI_Cart_get -- */

VT_MPI_INT MPI_Cart_get(MPI_Comm comm, VT_MPI_INT maxdims, VT_MPI_INT* dims, VT_MPI_INT* periods, VT_MPI_INT* coords)
{
  VT_MPI_INT result;
  uint64_t time;
  uint8_t was_recorded;

  if (IS_MPI_TRACE_ON)
  {
    MPI_TRACE_OFF();

    time = vt_pform_wtime();
    was_recorded = vt_enter(&time, vt_mpi_regid[VT__MPI_CART_GET]);

    CALL_PMPI_5(MPI_Cart_get, comm, maxdims, dims, periods, coords, result, 0, was_recorded, &time);

    time = vt_pform_wtime();
    vt_exit(&time);

    MPI_TRACE_ON();
  }
  else
  {
    CALL_PMPI_5(MPI_Cart_get, comm, maxdims, dims, periods, coords, result, 0, 0, NULL);
  }

  return result;
}

/* -- MPI_Cart_map -- */

VT_MPI_INT MPI_Cart_map(MPI_Comm comm, VT_MPI_INT ndims, VT_MPI_INT* dims, VT_MPI_INT* periods, VT_MPI_INT* newrank)
{
  VT_MPI_INT result;
  uint64_t time;
  uint8_t was_recorded;

  if (IS_MPI_TRACE_ON)
  {
    MPI_TRACE_OFF();

    time = vt_pform_wtime();
    was_recorded = vt_enter(&time, vt_mpi_regid[VT__MPI_CART_MAP]);

    CALL_PMPI_5(MPI_Cart_map, comm, ndims, dims, periods, newrank, result, 0, was_recorded, &time);

    time = vt_pform_wtime();
    vt_exit(&time);

    MPI_TRACE_ON();
  }
  else
  {
    CALL_PMPI_5(MPI_Cart_map, comm, ndims, dims, periods, newrank, result, 0, 0, NULL);
  }

  return result;
}

/* -- MPI_Cart_rank -- */

VT_MPI_INT MPI_Cart_rank(MPI_Comm comm, VT_MPI_INT* coords, VT_MPI_INT* rank)
{
  VT_MPI_INT result;
  uint64_t time;
  uint8_t was_recorded;

  if (IS_MPI_TRACE_ON)
  {
    MPI_TRACE_OFF();

    time = vt_pform_wtime();
    was_recorded = vt_enter(&time, vt_mpi_regid[VT__MPI_CART_RANK]);

    CALL_PMPI_3(MPI_Cart_rank, comm, coords, rank, result, 0, was_recorded, &time);

    time = vt_pform_wtime();
    vt_exit(&time);

    MPI_TRACE_ON();
  }
  else
  {
    CALL_PMPI_3(MPI_Cart_rank, comm, coords, rank, result, 0, 0, NULL);
  }

  return result;
}

/* -- MPI_Cart_shift -- */

VT_MPI_INT MPI_Cart_shift(MPI_Comm comm, VT_MPI_INT direction, VT_MPI_INT disp, VT_MPI_INT* rank_source, VT_MPI_INT* rank_dest)
{
  VT_MPI_INT result;
  uint64_t time;
  uint8_t was_recorded;

  if (IS_MPI_TRACE_ON)
  {
    MPI_TRACE_OFF();

    time = vt_pform_wtime();
    was_recorded = vt_enter(&time, vt_mpi_regid[VT__MPI_CART_SHIFT]);

    CALL_PMPI_5(MPI_Cart_shift, comm, direction, disp, rank_source, rank_dest, result, 0, was_recorded, &time);

    time = vt_pform_wtime();
    vt_exit(&time);

    MPI_TRACE_ON();
  }
  else
  {
    CALL_PMPI_5(MPI_Cart_shift, comm, direction, disp, rank_source, rank_dest, result, 0, 0, NULL);
  }

  return result;
}

/* -- MPI_Cart_sub -- not generated */

/* -- MPI_Cartdim_get -- */

VT_MPI_INT MPI_Cartdim_get(MPI_Comm comm, VT_MPI_INT* ndims)
{
  VT_MPI_INT result;
  uint64_t time;
  uint8_t was_recorded;

  if (IS_MPI_TRACE_ON)
  {
    MPI_TRACE_OFF();

    time = vt_pform_wtime();
    was_recorded = vt_enter(&time, vt_mpi_regid[VT__MPI_CARTDIM_GET]);

    CALL_PMPI_2(MPI_Cartdim_get, comm, ndims, result, 0, was_recorded, &time);

    time = vt_pform_wtime();
    vt_exit(&time);

    MPI_TRACE_ON();
  }
  else
  {
    CALL_PMPI_2(MPI_Cartdim_get, comm, ndims, result, 0, 0, NULL);
  }

  return result;
}

/* -- MPI_Comm_compare -- */

VT_MPI_INT MPI_Comm_compare(MPI_Comm comm1, MPI_Comm comm2, VT_MPI_INT* _result)
{
  VT_MPI_INT result;
  uint64_t time;
  uint8_t was_recorded;

  if (IS_MPI_TRACE_ON)
  {
    MPI_TRACE_OFF();

    time = vt_pform_wtime();
    was_recorded = vt_enter(&time, vt_mpi_regid[VT__MPI_COMM_COMPARE]);

    CALL_PMPI_3(MPI_Comm_compare, comm1, comm2, _result, result, 0, was_recorded, &time);

    time = vt_pform_wtime();
    vt_exit(&time);

    MPI_TRACE_ON();
  }
  else
  {
    CALL_PMPI_3(MPI_Comm_compare, comm1, comm2, _result, result, 0, 0, NULL);
  }

  return result;
}

/* -- MPI_Comm_create -- not generated */

/* -- MPI_Comm_dup -- not generated */

/* -- MPI_Comm_free -- not generated */

/* -- MPI_Comm_group -- */

VT_MPI_INT MPI_Comm_group(MPI_Comm comm, MPI_Group* group_CLASS_SINGLE_OUT)
{
  VT_MPI_INT result;
  uint64_t time;
  uint8_t was_recorded;

  if (IS_MPI_TRACE_ON)
  {
    MPI_TRACE_OFF();

    time = vt_pform_wtime();
    was_recorded = vt_enter(&time, vt_mpi_regid[VT__MPI_COMM_GROUP]);

    CALL_PMPI_2(MPI_Comm_group, comm, group_CLASS_SINGLE_OUT, result, 0, was_recorded, &time);

    time = vt_pform_wtime();
    vt_exit(&time);

    MPI_TRACE_ON();
  }
  else
  {
    CALL_PMPI_2(MPI_Comm_group, comm, group_CLASS_SINGLE_OUT, result, 0, 0, NULL);
  }

  return result;
}

/* -- MPI_Comm_rank -- */

VT_MPI_INT MPI_Comm_rank(MPI_Comm comm, VT_MPI_INT* rank)
{
  VT_MPI_INT result;
  uint64_t time;
  uint8_t was_recorded;

  if (IS_MPI_TRACE_ON)
  {
    MPI_TRACE_OFF();

    time = vt_pform_wtime();
    was_recorded = vt_enter(&time, vt_mpi_regid[VT__MPI_COMM_RANK]);

    CALL_PMPI_2(MPI_Comm_rank, comm, rank, result, 0, was_recorded, &time);

    time = vt_pform_wtime();
    vt_exit(&time);

    MPI_TRACE_ON();
  }
  else
  {
    CALL_PMPI_2(MPI_Comm_rank, comm, rank, result, 0, 0, NULL);
  }

  return result;
}

/* -- MPI_Comm_remote_group -- */

VT_MPI_INT MPI_Comm_remote_group(MPI_Comm comm, MPI_Group* group_CLASS_SINGLE_OUT)
{
  VT_MPI_INT result;
  uint64_t time;
  uint8_t was_recorded;

  if (IS_MPI_TRACE_ON)
  {
    MPI_TRACE_OFF();

    time = vt_pform_wtime();
    was_recorded = vt_enter(&time, vt_mpi_regid[VT__MPI_COMM_REMOTE_GROUP]);

    CALL_PMPI_2(MPI_Comm_remote_group, comm, group_CLASS_SINGLE_OUT, result, 0, was_recorded, &time);

    time = vt_pform_wtime();
    vt_exit(&time);

    MPI_TRACE_ON();
  }
  else
  {
    CALL_PMPI_2(MPI_Comm_remote_group, comm, group_CLASS_SINGLE_OUT, result, 0, 0, NULL);
  }

  return result;
}

/* -- MPI_Comm_remote_size -- */

VT_MPI_INT MPI_Comm_remote_size(MPI_Comm comm, VT_MPI_INT* size)
{
  VT_MPI_INT result;
  uint64_t time;
  uint8_t was_recorded;

  if (IS_MPI_TRACE_ON)
  {
    MPI_TRACE_OFF();

    time = vt_pform_wtime();
    was_recorded = vt_enter(&time, vt_mpi_regid[VT__MPI_COMM_REMOTE_SIZE]);

    CALL_PMPI_2(MPI_Comm_remote_size, comm, size, result, 0, was_recorded, &time);

    time = vt_pform_wtime();
    vt_exit(&time);

    MPI_TRACE_ON();
  }
  else
  {
    CALL_PMPI_2(MPI_Comm_remote_size, comm, size, result, 0, 0, NULL);
  }

  return result;
}

/* -- MPI_Comm_size -- */

VT_MPI_INT MPI_Comm_size(MPI_Comm comm, VT_MPI_INT* size)
{
  VT_MPI_INT result;
  uint64_t time;
  uint8_t was_recorded;

  if (IS_MPI_TRACE_ON)
  {
    MPI_TRACE_OFF();

    time = vt_pform_wtime();
    was_recorded = vt_enter(&time, vt_mpi_regid[VT__MPI_COMM_SIZE]);

    CALL_PMPI_2(MPI_Comm_size, comm, size, result, 0, was_recorded, &time);

    time = vt_pform_wtime();
    vt_exit(&time);

    MPI_TRACE_ON();
  }
  else
  {
    CALL_PMPI_2(MPI_Comm_size, comm, size, result, 0, 0, NULL);
  }

  return result;
}

/* -- MPI_Comm_split -- not generated */

/* -- MPI_Comm_test_inter -- */

VT_MPI_INT MPI_Comm_test_inter(MPI_Comm comm, VT_MPI_INT* flag)
{
  VT_MPI_INT result;
  uint64_t time;
  uint8_t was_recorded;

  if (IS_MPI_TRACE_ON)
  {
    MPI_TRACE_OFF();

    time = vt_pform_wtime();
    was_recorded = vt_enter(&time, vt_mpi_regid[VT__MPI_COMM_TEST_INTER]);

    CALL_PMPI_2(MPI_Comm_test_inter, comm, flag, result, 0, was_recorded, &time);

    time = vt_pform_wtime();
    vt_exit(&time);

    MPI_TRACE_ON();
  }
  else
  {
    CALL_PMPI_2(MPI_Comm_test_inter, comm, flag, result, 0, 0, NULL);
  }

  return result;
}

/* -- MPI_Dims_create -- */

VT_MPI_INT MPI_Dims_create(VT_MPI_INT nnodes, VT_MPI_INT ndims, VT_MPI_INT* dims)
{
  VT_MPI_INT result;
  uint64_t time;
  uint8_t was_recorded;

  if (IS_MPI_TRACE_ON)
  {
    MPI_TRACE_OFF();

    time = vt_pform_wtime();
    was_recorded = vt_enter(&time, vt_mpi_regid[VT__MPI_DIMS_CREATE]);

    CALL_PMPI_3(MPI_Dims_create, nnodes, ndims, dims, result, 0, was_recorded, &time);

    time = vt_pform_wtime();
    vt_exit(&time);

    MPI_TRACE_ON();
  }
  else
  {
    CALL_PMPI_3(MPI_Dims_create, nnodes, ndims, dims, result, 0, 0, NULL);
  }

  return result;
}

/* -- MPI_Errhandler_create -- */

VT_MPI_INT MPI_Errhandler_create(MPI_Handler_function* function, MPI_Errhandler* errhandler_CLASS_SINGLE_OUT)
{
  VT_MPI_INT result;
  uint64_t time;
  uint8_t was_recorded;

  if (IS_MPI_TRACE_ON)
  {
    MPI_TRACE_OFF();

    time = vt_pform_wtime();
    was_recorded = vt_enter(&time, vt_mpi_regid[VT__MPI_ERRHANDLER_CREATE]);

    CALL_PMPI_2(MPI_Errhandler_create, function, errhandler_CLASS_SINGLE_OUT, result, 0, was_recorded, &time);

    time = vt_pform_wtime();
    vt_exit(&time);

    MPI_TRACE_ON();
  }
  else
  {
    CALL_PMPI_2(MPI_Errhandler_create, function, errhandler_CLASS_SINGLE_OUT, result, 0, 0, NULL);
  }

  return result;
}

/* -- MPI_Errhandler_free -- */

VT_MPI_INT MPI_Errhandler_free(MPI_Errhandler* errhandler_CLASS_SINGLE_IN)
{
  VT_MPI_INT result;
  uint64_t time;
  uint8_t was_recorded;

  if (IS_MPI_TRACE_ON)
  {
    MPI_TRACE_OFF();

    time = vt_pform_wtime();
    was_recorded = vt_enter(&time, vt_mpi_regid[VT__MPI_ERRHANDLER_FREE]);

    CALL_PMPI_1(MPI_Errhandler_free, errhandler_CLASS_SINGLE_IN, result, 0, was_recorded, &time);

    time = vt_pform_wtime();
    vt_exit(&time);

    MPI_TRACE_ON();
  }
  else
  {
    CALL_PMPI_1(MPI_Errhandler_free, errhandler_CLASS_SINGLE_IN, result, 0, 0, NULL);
  }

  return result;
}

/* -- MPI_Errhandler_get -- */

VT_MPI_INT MPI_Errhandler_get(MPI_Comm comm, MPI_Errhandler* errhandler_CLASS_SINGLE_OUT)
{
  VT_MPI_INT result;
  uint64_t time;
  uint8_t was_recorded;

  if (IS_MPI_TRACE_ON)
  {
    MPI_TRACE_OFF();

    time = vt_pform_wtime();
    was_recorded = vt_enter(&time, vt_mpi_regid[VT__MPI_ERRHANDLER_GET]);

    CALL_PMPI_2(MPI_Errhandler_get, comm, errhandler_CLASS_SINGLE_OUT, result, 0, was_recorded, &time);

    time = vt_pform_wtime();
    vt_exit(&time);

    MPI_TRACE_ON();
  }
  else
  {
    CALL_PMPI_2(MPI_Errhandler_get, comm, errhandler_CLASS_SINGLE_OUT, result, 0, 0, NULL);
  }

  return result;
}

/* -- MPI_Errhandler_set -- */

VT_MPI_INT MPI_Errhandler_set(MPI_Comm comm, MPI_Errhandler errhandler)
{
  VT_MPI_INT result;
  uint64_t time;
  uint8_t was_recorded;

  if (IS_MPI_TRACE_ON)
  {
    MPI_TRACE_OFF();

    time = vt_pform_wtime();
    was_recorded = vt_enter(&time, vt_mpi_regid[VT__MPI_ERRHANDLER_SET]);

    CALL_PMPI_2(MPI_Errhandler_set, comm, errhandler, result, 0, was_recorded, &time);

    time = vt_pform_wtime();
    vt_exit(&time);

    MPI_TRACE_ON();
  }
  else
  {
    CALL_PMPI_2(MPI_Errhandler_set, comm, errhandler, result, 0, 0, NULL);
  }

  return result;
}

/* -- MPI_Error_class -- */

VT_MPI_INT MPI_Error_class(VT_MPI_INT errorcode, VT_MPI_INT* errorclass)
{
  VT_MPI_INT result;
  uint64_t time;
  uint8_t was_recorded;

  if (IS_MPI_TRACE_ON)
  {
    MPI_TRACE_OFF();

    time = vt_pform_wtime();
    was_recorded = vt_enter(&time, vt_mpi_regid[VT__MPI_ERROR_CLASS]);

    CALL_PMPI_2(MPI_Error_class, errorcode, errorclass, result, 0, was_recorded, &time);

    time = vt_pform_wtime();
    vt_exit(&time);

    MPI_TRACE_ON();
  }
  else
  {
    CALL_PMPI_2(MPI_Error_class, errorcode, errorclass, result, 0, 0, NULL);
  }

  return result;
}

/* -- MPI_Error_string -- */

VT_MPI_INT MPI_Error_string(VT_MPI_INT errorcode, char* string_CLASS_SINGLE_OUT, VT_MPI_INT* resultlen)
{
  VT_MPI_INT result;
  uint64_t time;
  uint8_t was_recorded;

  if (IS_MPI_TRACE_ON)
  {
    MPI_TRACE_OFF();

    time = vt_pform_wtime();
    was_recorded = vt_enter(&time, vt_mpi_regid[VT__MPI_ERROR_STRING]);

    CALL_PMPI_3(MPI_Error_string, errorcode, string_CLASS_SINGLE_OUT, resultlen, result, 0, was_recorded, &time);

    time = vt_pform_wtime();
    vt_exit(&time);

    MPI_TRACE_ON();
  }
  else
  {
    CALL_PMPI_3(MPI_Error_string, errorcode, string_CLASS_SINGLE_OUT, resultlen, result, 0, 0, NULL);
  }

  return result;
}

/* -- MPI_Finalize -- not generated */

/* -- MPI_Gather -- not generated */

/* -- MPI_Gatherv -- not generated */

/* -- MPI_Get_count -- */

VT_MPI_INT MPI_Get_count(MPI_Status* status_CLASS_SINGLE_IN, MPI_Datatype datatype, VT_MPI_INT* count)
{
  VT_MPI_INT result;
  uint64_t time;
  uint8_t was_recorded;

  if (IS_MPI_TRACE_ON)
  {
    MPI_TRACE_OFF();

    time = vt_pform_wtime();
    was_recorded = vt_enter(&time, vt_mpi_regid[VT__MPI_GET_COUNT]);

    CALL_PMPI_3(MPI_Get_count, status_CLASS_SINGLE_IN, datatype, count, result, 0, was_recorded, &time);

    time = vt_pform_wtime();
    vt_exit(&time);

    MPI_TRACE_ON();
  }
  else
  {
    CALL_PMPI_3(MPI_Get_count, status_CLASS_SINGLE_IN, datatype, count, result, 0, 0, NULL);
  }

  return result;
}

/* -- MPI_Get_elements -- */

VT_MPI_INT MPI_Get_elements(MPI_Status* status_CLASS_SINGLE_IN, MPI_Datatype datatype, VT_MPI_INT* count)
{
  VT_MPI_INT result;
  uint64_t time;
  uint8_t was_recorded;

  if (IS_MPI_TRACE_ON)
  {
    MPI_TRACE_OFF();

    time = vt_pform_wtime();
    was_recorded = vt_enter(&time, vt_mpi_regid[VT__MPI_GET_ELEMENTS]);

    CALL_PMPI_3(MPI_Get_elements, status_CLASS_SINGLE_IN, datatype, count, result, 0, was_recorded, &time);

    time = vt_pform_wtime();
    vt_exit(&time);

    MPI_TRACE_ON();
  }
  else
  {
    CALL_PMPI_3(MPI_Get_elements, status_CLASS_SINGLE_IN, datatype, count, result, 0, 0, NULL);
  }

  return result;
}

/* -- MPI_Get_processor_name -- */

VT_MPI_INT MPI_Get_processor_name(char* name_CLASS_SINGLE_OUT, VT_MPI_INT* resultlen)
{
  VT_MPI_INT result;
  uint64_t time;
  uint8_t was_recorded;

  if (IS_MPI_TRACE_ON)
  {
    MPI_TRACE_OFF();

    time = vt_pform_wtime();
    was_recorded = vt_enter(&time, vt_mpi_regid[VT__MPI_GET_PROCESSOR_NAME]);

    CALL_PMPI_2(MPI_Get_processor_name, name_CLASS_SINGLE_OUT, resultlen, result, 0, was_recorded, &time);

    time = vt_pform_wtime();
    vt_exit(&time);

    MPI_TRACE_ON();
  }
  else
  {
    CALL_PMPI_2(MPI_Get_processor_name, name_CLASS_SINGLE_OUT, resultlen, result, 0, 0, NULL);
  }

  return result;
}

/* -- MPI_Get_version -- */

VT_MPI_INT MPI_Get_version(VT_MPI_INT* version, VT_MPI_INT* subversion)
{
  VT_MPI_INT result;
  uint64_t time;
  uint8_t was_recorded;

  if (IS_MPI_TRACE_ON)
  {
    MPI_TRACE_OFF();

    time = vt_pform_wtime();
    was_recorded = vt_enter(&time, vt_mpi_regid[VT__MPI_GET_VERSION]);

    CALL_PMPI_2(MPI_Get_version, version, subversion, result, 0, was_recorded, &time);

    time = vt_pform_wtime();
    vt_exit(&time);

    MPI_TRACE_ON();
  }
  else
  {
    CALL_PMPI_2(MPI_Get_version, version, subversion, result, 0, 0, NULL);
  }

  return result;
}

/* -- MPI_Graph_create -- not generated */

/* -- MPI_Graph_get -- */

VT_MPI_INT MPI_Graph_get(MPI_Comm comm, VT_MPI_INT maxindex, VT_MPI_INT maxedges, VT_MPI_INT* index, VT_MPI_INT* edges)
{
  VT_MPI_INT result;
  uint64_t time;
  uint8_t was_recorded;

  if (IS_MPI_TRACE_ON)
  {
    MPI_TRACE_OFF();

    time = vt_pform_wtime();
    was_recorded = vt_enter(&time, vt_mpi_regid[VT__MPI_GRAPH_GET]);

    CALL_PMPI_5(MPI_Graph_get, comm, maxindex, maxedges, index, edges, result, 0, was_recorded, &time);

    time = vt_pform_wtime();
    vt_exit(&time);

    MPI_TRACE_ON();
  }
  else
  {
    CALL_PMPI_5(MPI_Graph_get, comm, maxindex, maxedges, index, edges, result, 0, 0, NULL);
  }

  return result;
}

/* -- MPI_Graph_map -- */

VT_MPI_INT MPI_Graph_map(MPI_Comm comm, VT_MPI_INT nnodes, VT_MPI_INT* index, VT_MPI_INT* edges, VT_MPI_INT* newrank)
{
  VT_MPI_INT result;
  uint64_t time;
  uint8_t was_recorded;

  if (IS_MPI_TRACE_ON)
  {
    MPI_TRACE_OFF();

    time = vt_pform_wtime();
    was_recorded = vt_enter(&time, vt_mpi_regid[VT__MPI_GRAPH_MAP]);

    CALL_PMPI_5(MPI_Graph_map, comm, nnodes, index, edges, newrank, result, 0, was_recorded, &time);

    time = vt_pform_wtime();
    vt_exit(&time);

    MPI_TRACE_ON();
  }
  else
  {
    CALL_PMPI_5(MPI_Graph_map, comm, nnodes, index, edges, newrank, result, 0, 0, NULL);
  }

  return result;
}

/* -- MPI_Graph_neighbors -- */

VT_MPI_INT MPI_Graph_neighbors(MPI_Comm comm, VT_MPI_INT rank, VT_MPI_INT maxneighbors, VT_MPI_INT* neighbors)
{
  VT_MPI_INT result;
  uint64_t time;
  uint8_t was_recorded;

  if (IS_MPI_TRACE_ON)
  {
    MPI_TRACE_OFF();

    time = vt_pform_wtime();
    was_recorded = vt_enter(&time, vt_mpi_regid[VT__MPI_GRAPH_NEIGHBORS]);

    CALL_PMPI_4(MPI_Graph_neighbors, comm, rank, maxneighbors, neighbors, result, 0, was_recorded, &time);

    time = vt_pform_wtime();
    vt_exit(&time);

    MPI_TRACE_ON();
  }
  else
  {
    CALL_PMPI_4(MPI_Graph_neighbors, comm, rank, maxneighbors, neighbors, result, 0, 0, NULL);
  }

  return result;
}

/* -- MPI_Graph_neighbors_count -- */

VT_MPI_INT MPI_Graph_neighbors_count(MPI_Comm comm, VT_MPI_INT rank, VT_MPI_INT* nneighbors)
{
  VT_MPI_INT result;
  uint64_t time;
  uint8_t was_recorded;

  if (IS_MPI_TRACE_ON)
  {
    MPI_TRACE_OFF();

    time = vt_pform_wtime();
    was_recorded = vt_enter(&time, vt_mpi_regid[VT__MPI_GRAPH_NEIGHBORS_COUNT]);

    CALL_PMPI_3(MPI_Graph_neighbors_count, comm, rank, nneighbors, result, 0, was_recorded, &time);

    time = vt_pform_wtime();
    vt_exit(&time);

    MPI_TRACE_ON();
  }
  else
  {
    CALL_PMPI_3(MPI_Graph_neighbors_count, comm, rank, nneighbors, result, 0, 0, NULL);
  }

  return result;
}

/* -- MPI_Graphdims_get -- */

VT_MPI_INT MPI_Graphdims_get(MPI_Comm comm, VT_MPI_INT* nnodes, VT_MPI_INT* nedges)
{
  VT_MPI_INT result;
  uint64_t time;
  uint8_t was_recorded;

  if (IS_MPI_TRACE_ON)
  {
    MPI_TRACE_OFF();

    time = vt_pform_wtime();
    was_recorded = vt_enter(&time, vt_mpi_regid[VT__MPI_GRAPHDIMS_GET]);

    CALL_PMPI_3(MPI_Graphdims_get, comm, nnodes, nedges, result, 0, was_recorded, &time);

    time = vt_pform_wtime();
    vt_exit(&time);

    MPI_TRACE_ON();
  }
  else
  {
    CALL_PMPI_3(MPI_Graphdims_get, comm, nnodes, nedges, result, 0, 0, NULL);
  }

  return result;
}

/* -- MPI_Group_compare -- */

VT_MPI_INT MPI_Group_compare(MPI_Group group1, MPI_Group group2, VT_MPI_INT* _result)
{
  VT_MPI_INT result;
  uint64_t time;
  uint8_t was_recorded;

  if (IS_MPI_TRACE_ON)
  {
    MPI_TRACE_OFF();

    time = vt_pform_wtime();
    was_recorded = vt_enter(&time, vt_mpi_regid[VT__MPI_GROUP_COMPARE]);

    CALL_PMPI_3(MPI_Group_compare, group1, group2, _result, result, 0, was_recorded, &time);

    time = vt_pform_wtime();
    vt_exit(&time);

    MPI_TRACE_ON();
  }
  else
  {
    CALL_PMPI_3(MPI_Group_compare, group1, group2, _result, result, 0, 0, NULL);
  }

  return result;
}

/* -- MPI_Group_difference -- not generated */

/* -- MPI_Group_excl -- not generated */

/* -- MPI_Group_free -- not generated */

/* -- MPI_Group_incl -- not generated */

/* -- MPI_Group_intersection -- not generated */

/* -- MPI_Group_range_excl -- not generated */

/* -- MPI_Group_range_incl -- not generated */

/* -- MPI_Group_rank -- */

VT_MPI_INT MPI_Group_rank(MPI_Group group, VT_MPI_INT* rank)
{
  VT_MPI_INT result;
  uint64_t time;
  uint8_t was_recorded;

  if (IS_MPI_TRACE_ON)
  {
    MPI_TRACE_OFF();

    time = vt_pform_wtime();
    was_recorded = vt_enter(&time, vt_mpi_regid[VT__MPI_GROUP_RANK]);

    CALL_PMPI_2(MPI_Group_rank, group, rank, result, 0, was_recorded, &time);

    time = vt_pform_wtime();
    vt_exit(&time);

    MPI_TRACE_ON();
  }
  else
  {
    CALL_PMPI_2(MPI_Group_rank, group, rank, result, 0, 0, NULL);
  }

  return result;
}

/* -- MPI_Group_size -- */

VT_MPI_INT MPI_Group_size(MPI_Group group, VT_MPI_INT* size)
{
  VT_MPI_INT result;
  uint64_t time;
  uint8_t was_recorded;

  if (IS_MPI_TRACE_ON)
  {
    MPI_TRACE_OFF();

    time = vt_pform_wtime();
    was_recorded = vt_enter(&time, vt_mpi_regid[VT__MPI_GROUP_SIZE]);

    CALL_PMPI_2(MPI_Group_size, group, size, result, 0, was_recorded, &time);

    time = vt_pform_wtime();
    vt_exit(&time);

    MPI_TRACE_ON();
  }
  else
  {
    CALL_PMPI_2(MPI_Group_size, group, size, result, 0, 0, NULL);
  }

  return result;
}

/* -- MPI_Group_translate_ranks -- */

VT_MPI_INT MPI_Group_translate_ranks(MPI_Group group1, VT_MPI_INT n, VT_MPI_INT* ranks1, MPI_Group group2, VT_MPI_INT* ranks2)
{
  VT_MPI_INT result;
  uint64_t time;
  uint8_t was_recorded;

  if (IS_MPI_TRACE_ON)
  {
    MPI_TRACE_OFF();

    time = vt_pform_wtime();
    was_recorded = vt_enter(&time, vt_mpi_regid[VT__MPI_GROUP_TRANSLATE_RANKS]);

    CALL_PMPI_5(MPI_Group_translate_ranks, group1, n, ranks1, group2, ranks2, result, 0, was_recorded, &time);

    time = vt_pform_wtime();
    vt_exit(&time);

    MPI_TRACE_ON();
  }
  else
  {
    CALL_PMPI_5(MPI_Group_translate_ranks, group1, n, ranks1, group2, ranks2, result, 0, 0, NULL);
  }

  return result;
}

/* -- MPI_Group_union -- not generated */

/* -- MPI_Ibsend -- not generated */

/* -- MPI_Init -- not generated */

/* -- MPI_Initialized -- not generated */

/* -- MPI_Intercomm_create -- not generated */

/* -- MPI_Intercomm_merge -- not generated */

/* -- MPI_Iprobe -- */

VT_MPI_INT MPI_Iprobe(VT_MPI_INT source, VT_MPI_INT tag, MPI_Comm comm, VT_MPI_INT* flag, MPI_Status* status_CLASS_SINGLE_OUT)
{
  VT_MPI_INT result;
  uint64_t time;
  uint8_t was_recorded;

  if (IS_MPI_TRACE_ON)
  {
    MPI_TRACE_OFF();

    time = vt_pform_wtime();
    was_recorded = vt_enter(&time, vt_mpi_regid[VT__MPI_IPROBE]);

    CALL_PMPI_5(MPI_Iprobe, source, tag, comm, flag, status_CLASS_SINGLE_OUT, result, 0, was_recorded, &time);

    time = vt_pform_wtime();
    vt_exit(&time);

    MPI_TRACE_ON();
  }
  else
  {
    CALL_PMPI_5(MPI_Iprobe, source, tag, comm, flag, status_CLASS_SINGLE_OUT, result, 0, 0, NULL);
  }

  return result;
}

/* -- MPI_Irecv -- not generated */

/* -- MPI_Irsend -- not generated */

/* -- MPI_Isend -- not generated */

/* -- MPI_Issend -- not generated */

/* -- MPI_Keyval_create -- */

VT_MPI_INT MPI_Keyval_create(MPI_Copy_function* copy_fn, MPI_Delete_function* delete_fn, VT_MPI_INT* keyval, void* extra_state)
{
  VT_MPI_INT result;
  uint64_t time;
  uint8_t was_recorded;

  if (IS_MPI_TRACE_ON)
  {
    MPI_TRACE_OFF();

    time = vt_pform_wtime();
    was_recorded = vt_enter(&time, vt_mpi_regid[VT__MPI_KEYVAL_CREATE]);

    CALL_PMPI_4(MPI_Keyval_create, copy_fn, delete_fn, keyval, extra_state, result, 0, was_recorded, &time);

    time = vt_pform_wtime();
    vt_exit(&time);

    MPI_TRACE_ON();
  }
  else
  {
    CALL_PMPI_4(MPI_Keyval_create, copy_fn, delete_fn, keyval, extra_state, result, 0, 0, NULL);
  }

  return result;
}

/* -- MPI_Keyval_free -- */

VT_MPI_INT MPI_Keyval_free(VT_MPI_INT* keyval)
{
  VT_MPI_INT result;
  uint64_t time;
  uint8_t was_recorded;

  if (IS_MPI_TRACE_ON)
  {
    MPI_TRACE_OFF();

    time = vt_pform_wtime();
    was_recorded = vt_enter(&time, vt_mpi_regid[VT__MPI_KEYVAL_FREE]);

    CALL_PMPI_1(MPI_Keyval_free, keyval, result, 0, was_recorded, &time);

    time = vt_pform_wtime();
    vt_exit(&time);

    MPI_TRACE_ON();
  }
  else
  {
    CALL_PMPI_1(MPI_Keyval_free, keyval, result, 0, 0, NULL);
  }

  return result;
}

/* -- MPI_Op_create -- */

VT_MPI_INT MPI_Op_create(MPI_User_function* function, VT_MPI_INT commute, MPI_Op* op_CLASS_SINGLE_OUT)
{
  VT_MPI_INT result;
  uint64_t time;
  uint8_t was_recorded;

  if (IS_MPI_TRACE_ON)
  {
    MPI_TRACE_OFF();

    time = vt_pform_wtime();
    was_recorded = vt_enter(&time, vt_mpi_regid[VT__MPI_OP_CREATE]);

    CALL_PMPI_3(MPI_Op_create, function, commute, op_CLASS_SINGLE_OUT, result, 0, was_recorded, &time);

    time = vt_pform_wtime();
    vt_exit(&time);

    MPI_TRACE_ON();
  }
  else
  {
    CALL_PMPI_3(MPI_Op_create, function, commute, op_CLASS_SINGLE_OUT, result, 0, 0, NULL);
  }

  return result;
}

/* -- MPI_Op_free -- */

VT_MPI_INT MPI_Op_free(MPI_Op* op_CLASS_SINGLE_IO)
{
  VT_MPI_INT result;
  uint64_t time;
  uint8_t was_recorded;

  if (IS_MPI_TRACE_ON)
  {
    MPI_TRACE_OFF();

    time = vt_pform_wtime();
    was_recorded = vt_enter(&time, vt_mpi_regid[VT__MPI_OP_FREE]);

    CALL_PMPI_1(MPI_Op_free, op_CLASS_SINGLE_IO, result, 0, was_recorded, &time);

    time = vt_pform_wtime();
    vt_exit(&time);

    MPI_TRACE_ON();
  }
  else
  {
    CALL_PMPI_1(MPI_Op_free, op_CLASS_SINGLE_IO, result, 0, 0, NULL);
  }

  return result;
}

/* -- MPI_Pack -- */

VT_MPI_INT MPI_Pack(void* inbuf_CLASS_BUFFER, VT_MPI_INT incount, MPI_Datatype datatype, void* outbuf, VT_MPI_INT outsize, VT_MPI_INT* position, MPI_Comm comm)
{
  VT_MPI_INT result;
  uint64_t time;
  uint8_t was_recorded;

  if (IS_MPI_TRACE_ON)
  {
    MPI_TRACE_OFF();

    time = vt_pform_wtime();
    was_recorded = vt_enter(&time, vt_mpi_regid[VT__MPI_PACK]);

    CALL_PMPI_7(MPI_Pack, inbuf_CLASS_BUFFER, incount, datatype, outbuf, outsize, position, comm, result, 0, was_recorded, &time);

    time = vt_pform_wtime();
    vt_exit(&time);

    MPI_TRACE_ON();
  }
  else
  {
    CALL_PMPI_7(MPI_Pack, inbuf_CLASS_BUFFER, incount, datatype, outbuf, outsize, position, comm, result, 0, 0, NULL);
  }

  return result;
}

/* -- MPI_Pack_size -- */

VT_MPI_INT MPI_Pack_size(VT_MPI_INT incount, MPI_Datatype datatype, MPI_Comm comm, VT_MPI_INT* size)
{
  VT_MPI_INT result;
  uint64_t time;
  uint8_t was_recorded;

  if (IS_MPI_TRACE_ON)
  {
    MPI_TRACE_OFF();

    time = vt_pform_wtime();
    was_recorded = vt_enter(&time, vt_mpi_regid[VT__MPI_PACK_SIZE]);

    CALL_PMPI_4(MPI_Pack_size, incount, datatype, comm, size, result, 0, was_recorded, &time);

    time = vt_pform_wtime();
    vt_exit(&time);

    MPI_TRACE_ON();
  }
  else
  {
    CALL_PMPI_4(MPI_Pack_size, incount, datatype, comm, size, result, 0, 0, NULL);
  }

  return result;
}

/* -- MPI_Pcontrol -- not generated */

/* -- MPI_Probe -- */

VT_MPI_INT MPI_Probe(VT_MPI_INT source, VT_MPI_INT tag, MPI_Comm comm, MPI_Status* status_CLASS_SINGLE_OUT)
{
  VT_MPI_INT result;
  uint64_t time;
  uint8_t was_recorded;

  if (IS_MPI_TRACE_ON)
  {
    MPI_TRACE_OFF();

    time = vt_pform_wtime();
    was_recorded = vt_enter(&time, vt_mpi_regid[VT__MPI_PROBE]);

    CALL_PMPI_4(MPI_Probe, source, tag, comm, status_CLASS_SINGLE_OUT, result, 0, was_recorded, &time);

    time = vt_pform_wtime();
    vt_exit(&time);

    MPI_TRACE_ON();
  }
  else
  {
    CALL_PMPI_4(MPI_Probe, source, tag, comm, status_CLASS_SINGLE_OUT, result, 0, 0, NULL);
  }

  return result;
}

/* -- MPI_Recv -- not generated */

/* -- MPI_Recv_init -- not generated */

/* -- MPI_Reduce -- not generated */

/* -- MPI_Reduce_scatter -- not generated */

/* -- MPI_Request_free -- not generated */

/* -- MPI_Rsend -- not generated */

/* -- MPI_Rsend_init -- not generated */

/* -- MPI_Scan -- not generated */

/* -- MPI_Scatter -- not generated */

/* -- MPI_Scatterv -- not generated */

/* -- MPI_Send -- not generated */

/* -- MPI_Send_init -- not generated */

/* -- MPI_Sendrecv -- not generated */

/* -- MPI_Sendrecv_replace -- not generated */

/* -- MPI_Ssend -- not generated */

/* -- MPI_Ssend_init -- not generated */

/* -- MPI_Start -- not generated */

/* -- MPI_Startall -- not generated */

/* -- MPI_Test -- not generated */

/* -- MPI_Test_cancelled -- */

VT_MPI_INT MPI_Test_cancelled(MPI_Status* status_CLASS_SINGLE_IN, VT_MPI_INT* flag)
{
  VT_MPI_INT result;
  uint64_t time;
  uint8_t was_recorded;

  if (IS_MPI_TRACE_ON)
  {
    MPI_TRACE_OFF();

    time = vt_pform_wtime();
    was_recorded = vt_enter(&time, vt_mpi_regid[VT__MPI_TEST_CANCELLED]);

    CALL_PMPI_2(MPI_Test_cancelled, status_CLASS_SINGLE_IN, flag, result, 0, was_recorded, &time);

    time = vt_pform_wtime();
    vt_exit(&time);

    MPI_TRACE_ON();
  }
  else
  {
    CALL_PMPI_2(MPI_Test_cancelled, status_CLASS_SINGLE_IN, flag, result, 0, 0, NULL);
  }

  return result;
}

/* -- MPI_Testall -- not generated */

/* -- MPI_Testany -- not generated */

/* -- MPI_Testsome -- not generated */

/* -- MPI_Topo_test -- */

VT_MPI_INT MPI_Topo_test(MPI_Comm comm, VT_MPI_INT* status)
{
  VT_MPI_INT result;
  uint64_t time;
  uint8_t was_recorded;

  if (IS_MPI_TRACE_ON)
  {
    MPI_TRACE_OFF();

    time = vt_pform_wtime();
    was_recorded = vt_enter(&time, vt_mpi_regid[VT__MPI_TOPO_TEST]);

    CALL_PMPI_2(MPI_Topo_test, comm, status, result, 0, was_recorded, &time);

    time = vt_pform_wtime();
    vt_exit(&time);

    MPI_TRACE_ON();
  }
  else
  {
    CALL_PMPI_2(MPI_Topo_test, comm, status, result, 0, 0, NULL);
  }

  return result;
}

/* -- MPI_Type_commit -- */

VT_MPI_INT MPI_Type_commit(MPI_Datatype* datatype_CLASS_SINGLE_IO)
{
  VT_MPI_INT result;
  uint64_t time;
  uint8_t was_recorded;

  if (IS_MPI_TRACE_ON)
  {
    MPI_TRACE_OFF();

    time = vt_pform_wtime();
    was_recorded = vt_enter(&time, vt_mpi_regid[VT__MPI_TYPE_COMMIT]);

    CALL_PMPI_1(MPI_Type_commit, datatype_CLASS_SINGLE_IO, result, 0, was_recorded, &time);

    time = vt_pform_wtime();
    vt_exit(&time);

    MPI_TRACE_ON();
  }
  else
  {
    CALL_PMPI_1(MPI_Type_commit, datatype_CLASS_SINGLE_IO, result, 0, 0, NULL);
  }

  return result;
}

/* -- MPI_Type_contiguous -- */

VT_MPI_INT MPI_Type_contiguous(VT_MPI_INT count, MPI_Datatype oldtype, MPI_Datatype* newtype_CLASS_SINGLE_OUT)
{
  VT_MPI_INT result;
  uint64_t time;
  uint8_t was_recorded;

  if (IS_MPI_TRACE_ON)
  {
    MPI_TRACE_OFF();

    time = vt_pform_wtime();
    was_recorded = vt_enter(&time, vt_mpi_regid[VT__MPI_TYPE_CONTIGUOUS]);

    CALL_PMPI_3(MPI_Type_contiguous, count, oldtype, newtype_CLASS_SINGLE_OUT, result, 0, was_recorded, &time);

    time = vt_pform_wtime();
    vt_exit(&time);

    MPI_TRACE_ON();
  }
  else
  {
    CALL_PMPI_3(MPI_Type_contiguous, count, oldtype, newtype_CLASS_SINGLE_OUT, result, 0, 0, NULL);
  }

  return result;
}

/* -- MPI_Type_extent -- */

VT_MPI_INT MPI_Type_extent(MPI_Datatype datatype, MPI_Aint* extent_CLASS_SINGLE_OUT)
{
  VT_MPI_INT result;
  uint64_t time;
  uint8_t was_recorded;

  if (IS_MPI_TRACE_ON)
  {
    MPI_TRACE_OFF();

    time = vt_pform_wtime();
    was_recorded = vt_enter(&time, vt_mpi_regid[VT__MPI_TYPE_EXTENT]);

    CALL_PMPI_2(MPI_Type_extent, datatype, extent_CLASS_SINGLE_OUT, result, 0, was_recorded, &time);

    time = vt_pform_wtime();
    vt_exit(&time);

    MPI_TRACE_ON();
  }
  else
  {
    CALL_PMPI_2(MPI_Type_extent, datatype, extent_CLASS_SINGLE_OUT, result, 0, 0, NULL);
  }

  return result;
}

/* -- MPI_Type_free -- */

VT_MPI_INT MPI_Type_free(MPI_Datatype* datatype_CLASS_SINGLE_IO)
{
  VT_MPI_INT result;
  uint64_t time;
  uint8_t was_recorded;

  if (IS_MPI_TRACE_ON)
  {
    MPI_TRACE_OFF();

    time = vt_pform_wtime();
    was_recorded = vt_enter(&time, vt_mpi_regid[VT__MPI_TYPE_FREE]);

    CALL_PMPI_1(MPI_Type_free, datatype_CLASS_SINGLE_IO, result, 0, was_recorded, &time);

    time = vt_pform_wtime();
    vt_exit(&time);

    MPI_TRACE_ON();
  }
  else
  {
    CALL_PMPI_1(MPI_Type_free, datatype_CLASS_SINGLE_IO, result, 0, 0, NULL);
  }

  return result;
}

/* -- MPI_Type_hindexed -- */

VT_MPI_INT MPI_Type_hindexed(VT_MPI_INT count, VT_MPI_INT* array_of_blocklengths, MPI_Aint* array_of_displacements_CLASS_ARRAY_IN_count, MPI_Datatype oldtype, MPI_Datatype* newtype_CLASS_SINGLE_OUT)
{
  VT_MPI_INT result;
  uint64_t time;
  uint8_t was_recorded;

  if (IS_MPI_TRACE_ON)
  {
    MPI_TRACE_OFF();

    time = vt_pform_wtime();
    was_recorded = vt_enter(&time, vt_mpi_regid[VT__MPI_TYPE_HINDEXED]);

    CALL_PMPI_5(MPI_Type_hindexed, count, array_of_blocklengths, array_of_displacements_CLASS_ARRAY_IN_count, oldtype, newtype_CLASS_SINGLE_OUT, result, 0, was_recorded, &time);

    time = vt_pform_wtime();
    vt_exit(&time);

    MPI_TRACE_ON();
  }
  else
  {
    CALL_PMPI_5(MPI_Type_hindexed, count, array_of_blocklengths, array_of_displacements_CLASS_ARRAY_IN_count, oldtype, newtype_CLASS_SINGLE_OUT, result, 0, 0, NULL);
  }

  return result;
}

/* -- MPI_Type_hvector -- */

VT_MPI_INT MPI_Type_hvector(VT_MPI_INT count, VT_MPI_INT blocklength, MPI_Aint stride, MPI_Datatype oldtype, MPI_Datatype* newtype_CLASS_SINGLE_OUT)
{
  VT_MPI_INT result;
  uint64_t time;
  uint8_t was_recorded;

  if (IS_MPI_TRACE_ON)
  {
    MPI_TRACE_OFF();

    time = vt_pform_wtime();
    was_recorded = vt_enter(&time, vt_mpi_regid[VT__MPI_TYPE_HVECTOR]);

    CALL_PMPI_5(MPI_Type_hvector, count, blocklength, stride, oldtype, newtype_CLASS_SINGLE_OUT, result, 0, was_recorded, &time);

    time = vt_pform_wtime();
    vt_exit(&time);

    MPI_TRACE_ON();
  }
  else
  {
    CALL_PMPI_5(MPI_Type_hvector, count, blocklength, stride, oldtype, newtype_CLASS_SINGLE_OUT, result, 0, 0, NULL);
  }

  return result;
}

/* -- MPI_Type_indexed -- */

VT_MPI_INT MPI_Type_indexed(VT_MPI_INT count, VT_MPI_INT* array_of_blocklengths, VT_MPI_INT* array_of_displacements, MPI_Datatype oldtype, MPI_Datatype* newtype_CLASS_SINGLE_OUT)
{
  VT_MPI_INT result;
  uint64_t time;
  uint8_t was_recorded;

  if (IS_MPI_TRACE_ON)
  {
    MPI_TRACE_OFF();

    time = vt_pform_wtime();
    was_recorded = vt_enter(&time, vt_mpi_regid[VT__MPI_TYPE_INDEXED]);

    CALL_PMPI_5(MPI_Type_indexed, count, array_of_blocklengths, array_of_displacements, oldtype, newtype_CLASS_SINGLE_OUT, result, 0, was_recorded, &time);

    time = vt_pform_wtime();
    vt_exit(&time);

    MPI_TRACE_ON();
  }
  else
  {
    CALL_PMPI_5(MPI_Type_indexed, count, array_of_blocklengths, array_of_displacements, oldtype, newtype_CLASS_SINGLE_OUT, result, 0, 0, NULL);
  }

  return result;
}

/* -- MPI_Type_lb -- */

VT_MPI_INT MPI_Type_lb(MPI_Datatype datatype, MPI_Aint* displacement_CLASS_SINGLE_OUT)
{
  VT_MPI_INT result;
  uint64_t time;
  uint8_t was_recorded;

  if (IS_MPI_TRACE_ON)
  {
    MPI_TRACE_OFF();

    time = vt_pform_wtime();
    was_recorded = vt_enter(&time, vt_mpi_regid[VT__MPI_TYPE_LB]);

    CALL_PMPI_2(MPI_Type_lb, datatype, displacement_CLASS_SINGLE_OUT, result, 0, was_recorded, &time);

    time = vt_pform_wtime();
    vt_exit(&time);

    MPI_TRACE_ON();
  }
  else
  {
    CALL_PMPI_2(MPI_Type_lb, datatype, displacement_CLASS_SINGLE_OUT, result, 0, 0, NULL);
  }

  return result;
}

/* -- MPI_Type_size -- */

VT_MPI_INT MPI_Type_size(MPI_Datatype datatype, VT_MPI_INT* size)
{
  VT_MPI_INT result;
  uint64_t time;
  uint8_t was_recorded;

  if (IS_MPI_TRACE_ON)
  {
    MPI_TRACE_OFF();

    time = vt_pform_wtime();
    was_recorded = vt_enter(&time, vt_mpi_regid[VT__MPI_TYPE_SIZE]);

    CALL_PMPI_2(MPI_Type_size, datatype, size, result, 0, was_recorded, &time);

    time = vt_pform_wtime();
    vt_exit(&time);

    MPI_TRACE_ON();
  }
  else
  {
    CALL_PMPI_2(MPI_Type_size, datatype, size, result, 0, 0, NULL);
  }

  return result;
}

/* -- MPI_Type_struct -- */

VT_MPI_INT MPI_Type_struct(VT_MPI_INT count, VT_MPI_INT* array_of_blocklengths, MPI_Aint* array_of_displacements_CLASS_ARRAY_IN_count, MPI_Datatype* array_of_types_CLASS_ARRAY_IN_count, MPI_Datatype* newtype_CLASS_SINGLE_OUT)
{
  VT_MPI_INT result;
  uint64_t time;
  uint8_t was_recorded;

  if (IS_MPI_TRACE_ON)
  {
    MPI_TRACE_OFF();

    time = vt_pform_wtime();
    was_recorded = vt_enter(&time, vt_mpi_regid[VT__MPI_TYPE_STRUCT]);

    CALL_PMPI_5(MPI_Type_struct, count, array_of_blocklengths, array_of_displacements_CLASS_ARRAY_IN_count, array_of_types_CLASS_ARRAY_IN_count, newtype_CLASS_SINGLE_OUT, result, 0, was_recorded, &time);

    time = vt_pform_wtime();
    vt_exit(&time);

    MPI_TRACE_ON();
  }
  else
  {
    CALL_PMPI_5(MPI_Type_struct, count, array_of_blocklengths, array_of_displacements_CLASS_ARRAY_IN_count, array_of_types_CLASS_ARRAY_IN_count, newtype_CLASS_SINGLE_OUT, result, 0, 0, NULL);
  }

  return result;
}

/* -- MPI_Type_ub -- */

VT_MPI_INT MPI_Type_ub(MPI_Datatype datatype, MPI_Aint* displacement_CLASS_SINGLE_OUT)
{
  VT_MPI_INT result;
  uint64_t time;
  uint8_t was_recorded;

  if (IS_MPI_TRACE_ON)
  {
    MPI_TRACE_OFF();

    time = vt_pform_wtime();
    was_recorded = vt_enter(&time, vt_mpi_regid[VT__MPI_TYPE_UB]);

    CALL_PMPI_2(MPI_Type_ub, datatype, displacement_CLASS_SINGLE_OUT, result, 0, was_recorded, &time);

    time = vt_pform_wtime();
    vt_exit(&time);

    MPI_TRACE_ON();
  }
  else
  {
    CALL_PMPI_2(MPI_Type_ub, datatype, displacement_CLASS_SINGLE_OUT, result, 0, 0, NULL);
  }

  return result;
}

/* -- MPI_Type_vector -- */

VT_MPI_INT MPI_Type_vector(VT_MPI_INT count, VT_MPI_INT blocklength, VT_MPI_INT stride, MPI_Datatype oldtype, MPI_Datatype* newtype_CLASS_SINGLE_OUT)
{
  VT_MPI_INT result;
  uint64_t time;
  uint8_t was_recorded;

  if (IS_MPI_TRACE_ON)
  {
    MPI_TRACE_OFF();

    time = vt_pform_wtime();
    was_recorded = vt_enter(&time, vt_mpi_regid[VT__MPI_TYPE_VECTOR]);

    CALL_PMPI_5(MPI_Type_vector, count, blocklength, stride, oldtype, newtype_CLASS_SINGLE_OUT, result, 0, was_recorded, &time);

    time = vt_pform_wtime();
    vt_exit(&time);

    MPI_TRACE_ON();
  }
  else
  {
    CALL_PMPI_5(MPI_Type_vector, count, blocklength, stride, oldtype, newtype_CLASS_SINGLE_OUT, result, 0, 0, NULL);
  }

  return result;
}

/* -- MPI_Unpack -- */

VT_MPI_INT MPI_Unpack(void* inbuf, VT_MPI_INT insize, VT_MPI_INT* position, void* outbuf_CLASS_BUFFER, VT_MPI_INT outcount, MPI_Datatype datatype, MPI_Comm comm)
{
  VT_MPI_INT result;
  uint64_t time;
  uint8_t was_recorded;

  if (IS_MPI_TRACE_ON)
  {
    MPI_TRACE_OFF();

    time = vt_pform_wtime();
    was_recorded = vt_enter(&time, vt_mpi_regid[VT__MPI_UNPACK]);

    CALL_PMPI_7(MPI_Unpack, inbuf, insize, position, outbuf_CLASS_BUFFER, outcount, datatype, comm, result, 0, was_recorded, &time);

    time = vt_pform_wtime();
    vt_exit(&time);

    MPI_TRACE_ON();
  }
  else
  {
    CALL_PMPI_7(MPI_Unpack, inbuf, insize, position, outbuf_CLASS_BUFFER, outcount, datatype, comm, result, 0, 0, NULL);
  }

  return result;
}

/* -- MPI_Wait -- not generated */

/* -- MPI_Waitall -- not generated */

/* -- MPI_Waitany -- not generated */

/* -- MPI_Waitsome -- not generated */

/* -- MPI_Wtick -- not generated */

/* -- MPI_Wtime -- not generated */

/* -- MPI_Init_thread -- not generated */

/* -- MPI_Is_thread_main -- */

VT_MPI_INT MPI_Is_thread_main(VT_MPI_INT* flag)
{
  VT_MPI_INT result;
  uint64_t time;
  uint8_t was_recorded;

  if (IS_MPI_TRACE_ON)
  {
    MPI_TRACE_OFF();

    time = vt_pform_wtime();
    was_recorded = vt_enter(&time, vt_mpi_regid[VT__MPI_IS_THREAD_MAIN]);

    CALL_PMPI_1(MPI_Is_thread_main, flag, result, 0, was_recorded, &time);

    time = vt_pform_wtime();
    vt_exit(&time);

    MPI_TRACE_ON();
  }
  else
  {
    CALL_PMPI_1(MPI_Is_thread_main, flag, result, 0, 0, NULL);
  }

  return result;
}

/* -- MPI_Query_thread -- */

VT_MPI_INT MPI_Query_thread(VT_MPI_INT* provided)
{
  VT_MPI_INT result;
  uint64_t time;
  uint8_t was_recorded;

  if (IS_MPI_TRACE_ON)
  {
    MPI_TRACE_OFF();

    time = vt_pform_wtime();
    was_recorded = vt_enter(&time, vt_mpi_regid[VT__MPI_QUERY_THREAD]);

    CALL_PMPI_1(MPI_Query_thread, provided, result, 0, was_recorded, &time);

    time = vt_pform_wtime();
    vt_exit(&time);

    MPI_TRACE_ON();
  }
  else
  {
    CALL_PMPI_1(MPI_Query_thread, provided, result, 0, 0, NULL);
  }

  return result;
}

/* -- MPI_Accumulate -- not generated */

/* -- MPI_Get -- not generated */

/* -- MPI_Put -- not generated */

/* -- MPI_Win_complete -- not generated */

/* -- MPI_Win_create -- not generated */

/* -- MPI_Win_fence -- not generated */

/* -- MPI_Win_free -- not generated */

/* -- MPI_Win_lock -- not generated */

/* -- MPI_Win_post -- not generated */

/* -- MPI_Win_start -- not generated */

/* -- MPI_Win_test -- not generated */

/* -- MPI_Win_unlock -- not generated */

/* -- MPI_Win_wait -- not generated */

/* -- MPI_Alltoallw -- not generated */

/* -- MPI_Exscan -- not generated */

/* -- MPI_File_call_errhandler -- not generated */

/* -- MPI_File_create_errhandler -- not generated */

/* -- MPI_File_get_errhandler -- not generated */

/* -- MPI_File_set_errhandler -- not generated */

/* -- MPI_File_open -- not generated */

/* -- MPI_File_close -- not generated */

/* -- MPI_File_delete -- not generated */

/* -- MPI_File_set_size -- */

VT_MPI_INT MPI_File_set_size(MPI_File fh, MPI_Offset size)
{
  VT_MPI_INT result;
  uint64_t time;
  uint8_t was_recorded;

  if (IS_MPI_TRACE_ON)
  {
    MPI_TRACE_OFF();

    time = vt_pform_wtime();
    was_recorded = vt_enter(&time, vt_mpi_regid[VT__MPI_FILE_SET_SIZE]);

    CALL_PMPI_2(MPI_File_set_size, fh, size, result, 0, was_recorded, &time);

    time = vt_pform_wtime();
    vt_exit(&time);

    MPI_TRACE_ON();
  }
  else
  {
    CALL_PMPI_2(MPI_File_set_size, fh, size, result, 0, 0, NULL);
  }

  return result;
}

/* -- MPI_File_preallocate -- not generated */

/* -- MPI_File_get_size -- */

VT_MPI_INT MPI_File_get_size(MPI_File fh, MPI_Offset* size_CLASS_SINGLE_OUT)
{
  VT_MPI_INT result;
  uint64_t time;
  uint8_t was_recorded;

  if (IS_MPI_TRACE_ON)
  {
    MPI_TRACE_OFF();

    time = vt_pform_wtime();
    was_recorded = vt_enter(&time, vt_mpi_regid[VT__MPI_FILE_GET_SIZE]);

    CALL_PMPI_2(MPI_File_get_size, fh, size_CLASS_SINGLE_OUT, result, 0, was_recorded, &time);

    time = vt_pform_wtime();
    vt_exit(&time);

    MPI_TRACE_ON();
  }
  else
  {
    CALL_PMPI_2(MPI_File_get_size, fh, size_CLASS_SINGLE_OUT, result, 0, 0, NULL);
  }

  return result;
}

/* -- MPI_File_get_group -- */

VT_MPI_INT MPI_File_get_group(MPI_File fh, MPI_Group* group_CLASS_SINGLE_OUT)
{
  VT_MPI_INT result;
  uint64_t time;
  uint8_t was_recorded;

  if (IS_MPI_TRACE_ON)
  {
    MPI_TRACE_OFF();

    time = vt_pform_wtime();
    was_recorded = vt_enter(&time, vt_mpi_regid[VT__MPI_FILE_GET_GROUP]);

    CALL_PMPI_2(MPI_File_get_group, fh, group_CLASS_SINGLE_OUT, result, 0, was_recorded, &time);

    time = vt_pform_wtime();
    vt_exit(&time);

    MPI_TRACE_ON();
  }
  else
  {
    CALL_PMPI_2(MPI_File_get_group, fh, group_CLASS_SINGLE_OUT, result, 0, 0, NULL);
  }

  return result;
}

/* -- MPI_File_get_amode -- */

VT_MPI_INT MPI_File_get_amode(MPI_File fh, VT_MPI_INT* amode)
{
  VT_MPI_INT result;
  uint64_t time;
  uint8_t was_recorded;

  if (IS_MPI_TRACE_ON)
  {
    MPI_TRACE_OFF();

    time = vt_pform_wtime();
    was_recorded = vt_enter(&time, vt_mpi_regid[VT__MPI_FILE_GET_AMODE]);

    CALL_PMPI_2(MPI_File_get_amode, fh, amode, result, 0, was_recorded, &time);

    time = vt_pform_wtime();
    vt_exit(&time);

    MPI_TRACE_ON();
  }
  else
  {
    CALL_PMPI_2(MPI_File_get_amode, fh, amode, result, 0, 0, NULL);
  }

  return result;
}

/* -- MPI_File_set_info -- */

VT_MPI_INT MPI_File_set_info(MPI_File fh, MPI_Info info)
{
  VT_MPI_INT result;
  uint64_t time;
  uint8_t was_recorded;

  if (IS_MPI_TRACE_ON)
  {
    MPI_TRACE_OFF();

    time = vt_pform_wtime();
    was_recorded = vt_enter(&time, vt_mpi_regid[VT__MPI_FILE_SET_INFO]);

    CALL_PMPI_2(MPI_File_set_info, fh, info, result, 0, was_recorded, &time);

    time = vt_pform_wtime();
    vt_exit(&time);

    MPI_TRACE_ON();
  }
  else
  {
    CALL_PMPI_2(MPI_File_set_info, fh, info, result, 0, 0, NULL);
  }

  return result;
}

/* -- MPI_File_get_info -- */

VT_MPI_INT MPI_File_get_info(MPI_File fh, MPI_Info* info_used_CLASS_SINGLE_OUT)
{
  VT_MPI_INT result;
  uint64_t time;
  uint8_t was_recorded;

  if (IS_MPI_TRACE_ON)
  {
    MPI_TRACE_OFF();

    time = vt_pform_wtime();
    was_recorded = vt_enter(&time, vt_mpi_regid[VT__MPI_FILE_GET_INFO]);

    CALL_PMPI_2(MPI_File_get_info, fh, info_used_CLASS_SINGLE_OUT, result, 0, was_recorded, &time);

    time = vt_pform_wtime();
    vt_exit(&time);

    MPI_TRACE_ON();
  }
  else
  {
    CALL_PMPI_2(MPI_File_get_info, fh, info_used_CLASS_SINGLE_OUT, result, 0, 0, NULL);
  }

  return result;
}

/* -- MPI_File_set_view -- */

VT_MPI_INT MPI_File_set_view(MPI_File fh, MPI_Offset disp, MPI_Datatype etype, MPI_Datatype filetype, char* datarep_CLASS_SINGLE_IN, MPI_Info info)
{
  VT_MPI_INT result;
  uint64_t time;
  uint8_t was_recorded;

  if (IS_MPI_TRACE_ON)
  {
    MPI_TRACE_OFF();

    time = vt_pform_wtime();
    was_recorded = vt_enter(&time, vt_mpi_regid[VT__MPI_FILE_SET_VIEW]);

    CALL_PMPI_6(MPI_File_set_view, fh, disp, etype, filetype, datarep_CLASS_SINGLE_IN, info, result, 0, was_recorded, &time);

    time = vt_pform_wtime();
    vt_exit(&time);

    MPI_TRACE_ON();
  }
  else
  {
    CALL_PMPI_6(MPI_File_set_view, fh, disp, etype, filetype, datarep_CLASS_SINGLE_IN, info, result, 0, 0, NULL);
  }

  return result;
}

/* -- MPI_File_get_view -- */

VT_MPI_INT MPI_File_get_view(MPI_File fh, MPI_Offset* disp_CLASS_SINGLE_OUT, MPI_Datatype* etype_CLASS_SINGLE_OUT, MPI_Datatype* filetype_CLASS_SINGLE_OUT, char* datarep_CLASS_SINGLE_OUT)
{
  VT_MPI_INT result;
  uint64_t time;
  uint8_t was_recorded;

  if (IS_MPI_TRACE_ON)
  {
    MPI_TRACE_OFF();

    time = vt_pform_wtime();
    was_recorded = vt_enter(&time, vt_mpi_regid[VT__MPI_FILE_GET_VIEW]);

    CALL_PMPI_5(MPI_File_get_view, fh, disp_CLASS_SINGLE_OUT, etype_CLASS_SINGLE_OUT, filetype_CLASS_SINGLE_OUT, datarep_CLASS_SINGLE_OUT, result, 0, was_recorded, &time);

    time = vt_pform_wtime();
    vt_exit(&time);

    MPI_TRACE_ON();
  }
  else
  {
    CALL_PMPI_5(MPI_File_get_view, fh, disp_CLASS_SINGLE_OUT, etype_CLASS_SINGLE_OUT, filetype_CLASS_SINGLE_OUT, datarep_CLASS_SINGLE_OUT, result, 0, 0, NULL);
  }

  return result;
}

/* -- MPI_File_read_at -- not generated */

/* -- MPI_File_read_at_all -- not generated */

/* -- MPI_File_write_at -- not generated */

/* -- MPI_File_write_at_all -- not generated */

/* -- MPI_File_iread_at -- not generated */

/* -- MPI_File_iwrite_at -- not generated */

/* -- MPI_File_read -- not generated */

/* -- MPI_File_read_all -- not generated */

/* -- MPI_File_write -- not generated */

/* -- MPI_File_write_all -- not generated */

/* -- MPI_File_iread -- not generated */

/* -- MPI_File_iwrite -- not generated */

/* -- MPI_File_seek -- not generated */

/* -- MPI_File_get_position -- */

VT_MPI_INT MPI_File_get_position(MPI_File fh, MPI_Offset* offset_CLASS_SINGLE_OUT)
{
  VT_MPI_INT result;
  uint64_t time;
  uint8_t was_recorded;

  if (IS_MPI_TRACE_ON)
  {
    MPI_TRACE_OFF();

    time = vt_pform_wtime();
    was_recorded = vt_enter(&time, vt_mpi_regid[VT__MPI_FILE_GET_POSITION]);

    CALL_PMPI_2(MPI_File_get_position, fh, offset_CLASS_SINGLE_OUT, result, 0, was_recorded, &time);

    time = vt_pform_wtime();
    vt_exit(&time);

    MPI_TRACE_ON();
  }
  else
  {
    CALL_PMPI_2(MPI_File_get_position, fh, offset_CLASS_SINGLE_OUT, result, 0, 0, NULL);
  }

  return result;
}

/* -- MPI_File_get_byte_offset -- */

VT_MPI_INT MPI_File_get_byte_offset(MPI_File fh, MPI_Offset offset, MPI_Offset* disp_CLASS_SINGLE_OUT)
{
  VT_MPI_INT result;
  uint64_t time;
  uint8_t was_recorded;

  if (IS_MPI_TRACE_ON)
  {
    MPI_TRACE_OFF();

    time = vt_pform_wtime();
    was_recorded = vt_enter(&time, vt_mpi_regid[VT__MPI_FILE_GET_BYTE_OFFSET]);

    CALL_PMPI_3(MPI_File_get_byte_offset, fh, offset, disp_CLASS_SINGLE_OUT, result, 0, was_recorded, &time);

    time = vt_pform_wtime();
    vt_exit(&time);

    MPI_TRACE_ON();
  }
  else
  {
    CALL_PMPI_3(MPI_File_get_byte_offset, fh, offset, disp_CLASS_SINGLE_OUT, result, 0, 0, NULL);
  }

  return result;
}

/* -- MPI_File_read_shared -- not generated */

/* -- MPI_File_write_shared -- not generated */

/* -- MPI_File_iread_shared -- not generated */

/* -- MPI_File_iwrite_shared -- not generated */

/* -- MPI_File_read_ordered -- not generated */

/* -- MPI_File_write_ordered -- not generated */

/* -- MPI_File_seek_shared -- not generated */

/* -- MPI_File_get_position_shared -- */

VT_MPI_INT MPI_File_get_position_shared(MPI_File fh, MPI_Offset* offset_CLASS_SINGLE_OUT)
{
  VT_MPI_INT result;
  uint64_t time;
  uint8_t was_recorded;

  if (IS_MPI_TRACE_ON)
  {
    MPI_TRACE_OFF();

    time = vt_pform_wtime();
    was_recorded = vt_enter(&time, vt_mpi_regid[VT__MPI_FILE_GET_POSITION_SHARED]);

    CALL_PMPI_2(MPI_File_get_position_shared, fh, offset_CLASS_SINGLE_OUT, result, 0, was_recorded, &time);

    time = vt_pform_wtime();
    vt_exit(&time);

    MPI_TRACE_ON();
  }
  else
  {
    CALL_PMPI_2(MPI_File_get_position_shared, fh, offset_CLASS_SINGLE_OUT, result, 0, 0, NULL);
  }

  return result;
}

/* -- MPI_File_read_at_all_begin -- not generated */

/* -- MPI_File_read_at_all_end -- not generated */

/* -- MPI_File_write_at_all_begin -- not generated */

/* -- MPI_File_write_at_all_end -- not generated */

/* -- MPI_File_read_all_begin -- not generated */

/* -- MPI_File_read_all_end -- not generated */

/* -- MPI_File_write_all_begin -- not generated */

/* -- MPI_File_write_all_end -- not generated */

/* -- MPI_File_read_ordered_begin -- not generated */

/* -- MPI_File_read_ordered_end -- not generated */

/* -- MPI_File_write_ordered_begin -- not generated */

/* -- MPI_File_write_ordered_end -- not generated */

/* -- MPI_File_get_type_extent -- */

VT_MPI_INT MPI_File_get_type_extent(MPI_File fh, MPI_Datatype datatype, MPI_Aint* extent_CLASS_SINGLE_OUT)
{
  VT_MPI_INT result;
  uint64_t time;
  uint8_t was_recorded;

  if (IS_MPI_TRACE_ON)
  {
    MPI_TRACE_OFF();

    time = vt_pform_wtime();
    was_recorded = vt_enter(&time, vt_mpi_regid[VT__MPI_FILE_GET_TYPE_EXTENT]);

    CALL_PMPI_3(MPI_File_get_type_extent, fh, datatype, extent_CLASS_SINGLE_OUT, result, 0, was_recorded, &time);

    time = vt_pform_wtime();
    vt_exit(&time);

    MPI_TRACE_ON();
  }
  else
  {
    CALL_PMPI_3(MPI_File_get_type_extent, fh, datatype, extent_CLASS_SINGLE_OUT, result, 0, 0, NULL);
  }

  return result;
}

/* -- MPI_File_set_atomicity -- */

VT_MPI_INT MPI_File_set_atomicity(MPI_File fh, VT_MPI_INT flag)
{
  VT_MPI_INT result;
  uint64_t time;
  uint8_t was_recorded;

  if (IS_MPI_TRACE_ON)
  {
    MPI_TRACE_OFF();

    time = vt_pform_wtime();
    was_recorded = vt_enter(&time, vt_mpi_regid[VT__MPI_FILE_SET_ATOMICITY]);

    CALL_PMPI_2(MPI_File_set_atomicity, fh, flag, result, 0, was_recorded, &time);

    time = vt_pform_wtime();
    vt_exit(&time);

    MPI_TRACE_ON();
  }
  else
  {
    CALL_PMPI_2(MPI_File_set_atomicity, fh, flag, result, 0, 0, NULL);
  }

  return result;
}

/* -- MPI_File_get_atomicity -- */

VT_MPI_INT MPI_File_get_atomicity(MPI_File fh, VT_MPI_INT* flag)
{
  VT_MPI_INT result;
  uint64_t time;
  uint8_t was_recorded;

  if (IS_MPI_TRACE_ON)
  {
    MPI_TRACE_OFF();

    time = vt_pform_wtime();
    was_recorded = vt_enter(&time, vt_mpi_regid[VT__MPI_FILE_GET_ATOMICITY]);

    CALL_PMPI_2(MPI_File_get_atomicity, fh, flag, result, 0, was_recorded, &time);

    time = vt_pform_wtime();
    vt_exit(&time);

    MPI_TRACE_ON();
  }
  else
  {
    CALL_PMPI_2(MPI_File_get_atomicity, fh, flag, result, 0, 0, NULL);
  }

  return result;
}

/* -- MPI_File_sync -- not generated */

